<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>Object clone</title>
</head>
<body>
    <script>
        
        let me = {
            gender: "male",
            age: 29,
            religion: false,
            worldview: "secular transhumanism",
            favouriteMovie: "Shawshank redemption",
            favouriteBook: "HPMOR",
            skillset: {
                guitar: 1,
                basketball: 2,
                tableTennis: 3,
                english: {
                    grammar: 6,
                    spelling: 6,
                    vocabulary: 6,
                    pronunciation: 8
                },
                WebDev: {
                    designing: 5,
                    coding: 3
                },
                eating: 10
            },
            learn(time, effort, material) {
                return time * effort * material;
            }
        }

        let clone = obj => {
            let newObj = {};

            for(let key in obj) {
                if (typeof obj[key] === "object")
                    newObj[key] = clone(obj[key]);
                else
                    newObj[key] = obj[key];
            }

            return newObj;
        }

        let myClone = clone(me);
        myClone.skillset.english.grammar = 10;
        console.log(me);
        console.log(myClone);
        console.log(me.skillset.english.grammar);
        console.log(myClone.skillset.english.grammar);

    </script>
</body>
</html>